﻿namespace WpfOpgave.Entities
{
	public class Person : System.ICloneable
	{
		public string Company { get; set; }
		public string Name { get; set; }
		public string WorkTitle { get; set; }
		public string AddressLine1 { get; set; }
		public string ZipCode { get; set; }
		public string City { get; set; }
		public string Phone { get; set; }
		public string MobilePhone { get; set; }
		public PersonRole Role { get; set; }

		public override string ToString()
		{
			var sb = new System.Text.StringBuilder();

			sb.AppendLine("Person:");
			sb.AppendLine("  Company: " + Company);
			sb.AppendLine("  Name: " + Name);
			sb.AppendLine("  Work title: " + WorkTitle);
			sb.AppendLine("  Addressline1: " + AddressLine1);
			sb.AppendLine("  ZipCode/City: " + ZipCode + " / " + City);
			sb.AppendLine("  Phone/Mobile: " + Phone + " / " + MobilePhone);
			sb.AppendLine("  Role: " + Role.ToString());

			return sb.ToString();
		}

		object System.ICloneable.Clone()
		{
			return Clone();
		}

		public Person Clone()
		{
			return (Person)this.MemberwiseClone();
		}

		public void Update(Person other)
		{
			this.Company = other.Company;
			this.Name = other.Name;
			this.WorkTitle = other.WorkTitle;
			this.AddressLine1 = other.AddressLine1;
			this.ZipCode = other.ZipCode;
			this.City = other.City;
			this.Phone = other.Phone;
			this.MobilePhone = other.MobilePhone;
			this.Role = other.Role;
		}
	}
}
