﻿namespace WpfOpgave
{
	/// <summary>
	/// Interaction logic for Window2.xaml
	/// </summary>
	public partial class Window2 : System.Windows.Window
	{
		public Window2()
		{
			InitializeComponent();

			var clientArea = (System.Windows.Controls.Panel)Content;
			clientArea.Margin = new System.Windows.Thickness(3);
		}

		private void Button_Click(object sender, System.Windows.RoutedEventArgs e)
		{
			Close();
		}

		private Entities.PersonList _persons;
		private System.ComponentModel.ICollectionView _listboxView;

		private void Window_Loaded(object sender, System.Windows.RoutedEventArgs e)
		{
			_persons = Entities.EntitiesUtil.CreatePersonListTestData();

			ListBoxPerson.ItemsSource = _persons;

			// ListBoxPerson.DisplayMemberPath = "Name";

			_listboxView = System.Windows.Data.CollectionViewSource.GetDefaultView(ListBoxPerson.ItemsSource);
			_listboxView.GroupDescriptions.Add(new System.Windows.Data.PropertyGroupDescription("Role"));
			_listboxView.SortDescriptions.Add(new System.ComponentModel.SortDescription("Role", System.ComponentModel.ListSortDirection.Ascending));
		}

		private void ListBoxPerson_MouseDoubleClick(object sender, System.Windows.Input.MouseButtonEventArgs e)
		{
			var selectedItem = (Entities.Person)ListBoxPerson.SelectedValue;

			if (selectedItem != null)
			{
				var detailsWindow = new Window1();

				detailsWindow.Person = selectedItem.Clone();
				var dialogResult = detailsWindow.ShowDialog() ?? false;

				if (dialogResult)
				{
					selectedItem.Update(detailsWindow.Person);
					
					// ListBoxPerson.Items.Refresh();
					
					_listboxView.Refresh();
				}
			}
		}
	}
}
