﻿namespace WpfOpgave
{
	/// <summary>
	/// Interaction logic for UserControl1.xaml
	/// </summary>
	public partial class UserControl1 : System.Windows.Controls.UserControl
	{
		public UserControl1()
		{
			InitializeComponent();
		}

		protected Entities.Person _currentPerson;
		protected Entities.Person _nextPerson;

		public Entities.Person Person
		{
			get
			{
				return _currentPerson;
			}
			set
			{
				_nextPerson = value;

				//StartAnimation();
				StartAnimationExtraExercise();
			}
		}

		private void StartAnimation()
		{
			this.BeginAnimation(OpacityProperty, null);

			if (_nextPerson == _currentPerson)
			{
				DataContext = null; // Forces refresh
			}

			_currentPerson = _nextPerson; 
			DataContext = _currentPerson;

			var fadeAnimation = new System.Windows.Media.Animation.DoubleAnimation();
			fadeAnimation.BeginTime = System.TimeSpan.FromMilliseconds(300);
			fadeAnimation.To = 1;
			fadeAnimation.Duration = System.TimeSpan.FromMilliseconds(700);
			this.BeginAnimation(OpacityProperty, fadeAnimation);
		}

		private void StartAnimationExtraExercise()
		{
			var sb = (System.Windows.Media.Animation.Storyboard)this.Resources["FadeInOutStoryboard"];

			var kf = ((System.Windows.Media.Animation.ObjectAnimationUsingKeyFrames)sb.Children[1]).KeyFrames[1];
			_currentPerson = _nextPerson;
			kf.Value = _currentPerson;

			sb.Begin();
		}
	}
}
